--By Quaternions
local exp=math.exp
local sin=math.sin

local clear=love.graphics.clear
local draw=love.graphics.draw
local gprint=love.graphics.print
local rect=love.graphics.rectangle
local setCanvas=love.graphics.setCanvas
local setShader=love.graphics.setShader

local isDown=love.mouse.isDown

local tick=love.timer.getTime

--[[
local newImage=love.graphics.newImage
local newCanvas=love.graphics.newCanvas

local _0=newImage'0.png'
local _1=newImage'1.png'
--local _2=newImage'2.png'
--local _3=newImage'3.png'
--local _4=newImage'4.png'
--local _5=newImage'5.png'
--local _6=newImage'6.png'
--local _7=newImage'7.png'
--local _8=newImage'8.png'
--local _9=newImage'9.png'

function love.draw()
	local _0123456789=newCanvas(300,2*500)
	setCanvas(_0123456789)
	draw(_0,0,0)
	draw(_1,0,500)
	--draw(_2,0,2*500)
	--draw(_3,0,3*500)
	--draw(_4,0,4*500)
	--draw(_5,0,5*500)
	--draw(_6,0,6*500)
	--draw(_7,0,7*500)
	--draw(_8,0,8*500)
	--draw(_9,0,9*500)

	local out=love.filesystem.newFile'01.png'
	out:open'w'
	_0123456789:getImageData():encode(out)
	out:close()

	love.event.quit()
end
--]]

love.graphics.setColor(0,0,0,255)
love.graphics.setBackgroundColor(255,255,255,255)

local w,h=love.graphics.getDimensions()

local base=2

---[==[
NumberImage=love.graphics.newImage'01.png'
local NumberWidth=NumberImage:getWidth()
local NumberHeight=NumberImage:getHeight()

--Generate full resolution sum image
local TopDownSum=love.graphics.newCanvas(NumberWidth,NumberHeight,"rgba32f")
local TopDownShader=love.graphics.newShader'TopDown.glsl'
setShader(TopDownShader)
setCanvas(TopDownSum)
draw(NumberImage)

--the main meat
local MotionShader=love.graphics.newShader'Motion.glsl'
MotionShader:send("Font",NumberImage)
MotionShader:send("Sum",TopDownSum)
MotionShader:send("DSize",{base*h*NumberWidth/NumberHeight,h})
MotionShader:send("FontSize",{NumberWidth,NumberHeight/base})

setCanvas()

local t0=tick()+10
local thisNumber=0
local lastNumber=0
MotionShader:send("n0",lastNumber)

local pause=false

--local frame=0
--local divider=60
--let's run this
function love.draw()
	--[[
	if not pause then
		if frame<divider then
			frame=frame+1
		else
			--]]
			lastNumber=thisNumber
			thisNumber=exp(0.2*(tick()-t0))--10.5+1.5*sin(tick())--
			MotionShader:send("n0",lastNumber)
			MotionShader:send("n1",thisNumber)
			--[[
			frame=1
		end
	end
	--]=]
	--[[
	lastNumber=9.5+0.5*sin(tick())
	thisNumber=10.5+0.5*sin(tick()/3^0.5)
	MotionShader:send("n0",lastNumber)
	MotionShader:send("n1",thisNumber)
	--]]
	clear()
	setShader(MotionShader)
	rect("fill",0,0,w,h)
	setShader()
	gprint("n0: "..lastNumber,0,0)
	gprint("n1: "..thisNumber,0,20)
end

local b1d=isDown'l'
function love.update()
	local new_b1d=isDown'l'
	if new_b1d and not b1d then
		pause=not pause
	end
	b1d=new_b1d
end

function love.resize(x,y)
	w,h=x,y
	--Recache TopDown pixels for new number width?
	MotionShader:send("DSize",{base*h*NumberWidth/NumberHeight,h})
end
--]==]
